export type IPCChannel =
    'WIFI_SCAN'
    | 'WIFI_CONNECT'
    | 'FUNCTION_TEST'
    | 'CLOUD_STATUS'
    | 'CLOUD_CONNECT'
    | 'SETTINGS'
    | 'PREPARING'

export enum IPCListenChannels {
    'KEYPAD_INPUT'= 'KEYPAD_INPUT',
    'NFC_CARD'= 'NFC_CARD',
    'NFC_RAW' = 'NFC_RAW'
}

export interface IPCAnswer {
    status: boolean,
    data?: any
}

export interface IPCRequest {
    data?: any,
}

export interface WiFiNetwork {
    ssid: string,
    isSecured: boolean,
    isKnown?: boolean,
    psk?: string,
    rssi?: number,
}

export interface FunctionTest {
    hasSudo: boolean,
    hasWPASupplicant: boolean,
    hasInternet: boolean
}

export type GameSwitch = {
    name: GameSwitchNames,
    label: string,
    depends?: GameSwitchNames,
    value: boolean
}

export type GameInput = {
    name: GameInputNames,
    type: "number" | "string",
    label: string,
    depends?: GameSwitchNames,
    value: string
}

export type GameSwitchNames =
    "GET_BONUS_PASSING_START"
    | "DOUBLE_BONUS_ON_GO"
    | "PUT_PAID_PENALTIES_IN_MIDDLE"
    | "RECEIVE_PENALTIES_AT_FREE_PARKING"
    | "PUT_10_IN_MIDDLE_AFTER_EACH_GO"
    | "STREET_MUST_BE_AUCTIONED_IF_NOT_PURCHASED"
    | "TWO_HOTELS_PER_STREET_ALLOWED"
    | "MORTGAGE_REDUCES_RENT"
    | "GOODS_GO_TO_OTHER_PLAYERS_UPON_BANKRUPTCY"
    | "STREETS_CAN_BE_SOLD_BACK_TO_THE_BANK"
    | "PRISON_CAN_BE_PURCHASED_RENT_GOES_TO_PLAYER"
    | "KEEP_MONEY_MORE_SECRET";

export type GameInputNames =
    "PASSING_GO_CASH"
    | "STARTING_CASH"
    | "PRISON_RELEASE_FEE";

export interface GameRules {
    switchValues: { [key in GameSwitchNames]?: boolean },
    inputValues: { [key in GameInputNames]?: string }
}

export interface Config {
    rules?: GameRules
}

export enum NFCCardType {
    ACCOUNT,
    PROPERTY,
    TASK,
}

export interface NFCCard {
    cardType: NFCCardType,
    uid: string,
    raw: string
}

export interface NFCAccountCard extends NFCCard {
    symbol: string,
    friendlyName: string,
    pin: number
}

export interface NFCPropertyCard extends NFCCard {

}

export interface NFCTaskCard extends NFCCard {

}